﻿@page "/metas"

@using BlazorCrud.Shared;
@using CurrieTechnologies.Razor.SweetAlert2;
@using BlazorCrud.Client.Services;

@inject SweetAlertService Swal;
@inject IMetaService MetaService

<h3>Metas</h3>

<a class="btn btn-success btn-sm mb-3" href="meta">Nueva Meta</a>

<table class="table">
    <thead>
        <tr>
            <th>Nombre</th>
            <th>Fecha</th>
            <th>Activa</th>

        </tr>
    </thead>
    <tbody>

        @if (listaMeta == null)
        {

            <tr>
                <td colspan="3" align="center">
                    <img style="width:50px" src="https://media.tenor.com/On7kvXhzml4AAAAj/loading-gif.gif" />
                </td>
            </tr>
        }
        else
        {
            @foreach (var item in listaMeta)
            {
                <tr>
                    <td>@item.Id</td>
                    <td>@item.Nombre</td>
                    <td>@item.Fecha.ToString("dd/MM/yyyy")</td>
                    <td>@item.Activa</td>

                    <td>
                        <a class="btn btn-primary btn-sm" href="meta/@item.Id">
                            <i class="oi oi-pencil"></i>
                        </a>
                        <button type="button" class="btn btn-danger btn-sm ms-2" @onclick="(() => Eliminar(item.Id))">
                            <i class="oi oi-trash"></i>
                        </button>

                    </td>
                </tr>
            }
        }



    </tbody>
</table>


@code {
    List<MetaDTO>? listaMeta = null;


    protected override async Task OnInitializedAsync()
    {
        listaMeta = await MetaService.Lista();
    }

    private async Task Eliminar(int id)
    {
        var resultado = await Swal.FireAsync(new SweetAlertOptions
            {
                Title = "Eliminar Meta",
                Text = "Deseas eliminar esta Meta",
                Icon = SweetAlertIcon.Question,
                ShowCancelButton = true
            });

        if (resultado.IsConfirmed)
        {
            var eliminado = await MetaService.Eliminar(id);

            if (eliminado)
                listaMeta = listaMeta!.FindAll(e => e.Id != id);

        }


    }

}
